import { Injectable, NgModule } from '@angular/core';
import { HttpClient, HttpHeaders } from '@angular/common/http';
var __decorate$1 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
        return Reflect.metadata(k, v);
};
// Imports from @angular
var BaseResourceConfig = {
    requestOptions: {
        headers: new HttpHeaders({
            'content-type': 'application/json',
            'accept': 'application/json',
        })
    },
    auth: false,
    tokenPropertyName: 'accessToken'
};
var ResourceService = (function () {
    function ResourceService(http$$1) {
        this.http = http$$1;
        this.resourceConfig = BaseResourceConfig;
        if (BaseResourceConfig.auth) {
            this.authenticate();
        }
    }
    Object.defineProperty(ResourceService.prototype, "url", {
        get: function () { return this.baseUrl; },
        set: function (url) { this.baseUrl = url; },
        enumerable: true,
        configurable: true
    });
    ResourceService.prototype.authenticate = function () {
        var token = localStorage.getItem(this.resourceConfig.tokenPropertyName);
        if (this.resourceConfig.auth && token) {
            this.resourceConfig.requestOptions.headers = this.resourceConfig.requestOptions.headers.set('x-access-token', token);
        }
    };
    ResourceService.prototype.query = function (ids, config) {
        if (ids === void 0) { ids = {}; }
        if (config === void 0) { config = {}; }
        return this.request('Get', ids, config);
    };
    ResourceService.prototype.get = function (ids, config) {
        if (config === void 0) { config = {}; }
        return this.request('Get', ids, config);
    };
    ResourceService.prototype.save = function (data, ids, config) {
        if (ids === void 0) { ids = {}; }
        if (config === void 0) { config = {}; }
        return this.request('Post', ids, config, data);
    };
    ResourceService.prototype.update = function (data, ids, config) {
        if (config === void 0) { config = {}; }
        return this.request('Put', ids, config, data);
    };
    ResourceService.prototype.delete = function (ids, config) {
        if (config === void 0) { config = {}; }
        return this.request('Delete', ids, config);
    };
    ResourceService.prototype.search = function (config) {
        if (config === void 0) { config = {}; }
        config.urlSuffix = '/search';
        return this.request('Get', {}, config);
    };
    ResourceService.prototype.count = function (config) {
        if (config === void 0) { config = {}; }
        config.urlSuffix = '/count';
        return this.request('Get', {}, config);
    };
    ResourceService.prototype.request = function (method, ids, config, data) {
        if (config === void 0) { config = {}; }
        var token = localStorage.getItem(this.resourceConfig.tokenPropertyName);
        if (!config.requestOptions) {
            config.requestOptions = {};
        }
        if (this.resourceConfig.auth && token) {
            config.requestOptions.headers = new HttpHeaders({
                'content-type': 'application/json',
                'accept': 'application/json',
                'x-access-token': token
            });
        }
        var reqOpts = Object.assign({}, this.resourceConfig.requestOptions, config.requestOptions);
        reqOpts.method = method;
        reqOpts.params = config['params'] || null;
        reqOpts.body = JSON.stringify(data) || null;
        var url = this.makeUrl(ids) + (config['urlSuffix'] || '');
        return this.http.request(reqOpts.method, url, reqOpts);
    };
    ResourceService.prototype.makeUrl = function (obj) {
        var url = this.baseUrl;
        var params = url.match(/:\w+/g);
        if (!params) {
            return url;
        }
        params.forEach(function (param) {
            var key = param.substring(1, param.length);
            url = obj.hasOwnProperty(key) ?
                url.replace(param, obj[key]) :
                url.replace('/' + param, '');
        });
        return url;
    };
    return ResourceService;
}());
ResourceService = __decorate$1([
    Injectable(),
    __metadata("design:paramtypes", [HttpClient])
], ResourceService);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
// Imports from @angular
// Services
var ResourceModule = (function () {
    function ResourceModule() {
    }
    return ResourceModule;
}());
ResourceModule = __decorate([
    NgModule({ providers: [ResourceService] })
], ResourceModule);
/**
 * Generated bundle index. Do not edit.
 */
export { ResourceModule, BaseResourceConfig, ResourceService };
//# sourceMappingURL=ng-restly.es5.js.map
