import { Injectable, NgModule } from '@angular/core';
import { HttpClient, HttpHeaders } from '@angular/common/http';

var __decorate$1 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// Imports from @angular
const BaseResourceConfig = {
    requestOptions: {
        headers: new HttpHeaders({
            'content-type': 'application/json',
            'accept': 'application/json',
        })
    },
    auth: false,
    tokenPropertyName: 'accessToken'
};
let ResourceService = class ResourceService {
    constructor(http$$1) {
        this.http = http$$1;
        this.resourceConfig = BaseResourceConfig;
        if (BaseResourceConfig.auth) {
            this.authenticate();
        }
    }
    set url(url) { this.baseUrl = url; }
    get url() { return this.baseUrl; }
    authenticate() {
        const token = localStorage.getItem(this.resourceConfig.tokenPropertyName);
        if (this.resourceConfig.auth && token) {
            this.resourceConfig.requestOptions.headers = this.resourceConfig.requestOptions.headers.set('x-access-token', token);
        }
    }
    query(ids = {}, config = {}) {
        return this.request('Get', ids, config);
    }
    get(ids, config = {}) {
        return this.request('Get', ids, config);
    }
    save(data, ids = {}, config = {}) {
        return this.request('Post', ids, config, data);
    }
    update(data, ids, config = {}) {
        return this.request('Put', ids, config, data);
    }
    delete(ids, config = {}) {
        return this.request('Delete', ids, config);
    }
    search(config = {}) {
        config.urlSuffix = '/search';
        return this.request('Get', {}, config);
    }
    count(config = {}) {
        config.urlSuffix = '/count';
        return this.request('Get', {}, config);
    }
    request(method, ids, config = {}, data) {
        const token = localStorage.getItem(this.resourceConfig.tokenPropertyName);
        if (!config.requestOptions) {
            config.requestOptions = {};
        }
        if (this.resourceConfig.auth && token) {
            config.requestOptions.headers = new HttpHeaders({
                'content-type': 'application/json',
                'accept': 'application/json',
                'x-access-token': token
            });
        }
        const reqOpts = Object.assign({}, this.resourceConfig.requestOptions, config.requestOptions);
        reqOpts.method = method;
        reqOpts.params = config['params'] || null;
        reqOpts.body = JSON.stringify(data) || null;
        const url = this.makeUrl(ids) + (config['urlSuffix'] || '');
        return this.http.request(reqOpts.method, url, reqOpts);
    }
    makeUrl(obj) {
        let url = this.baseUrl;
        const params = url.match(/:\w+/g);
        if (!params) {
            return url;
        }
        params.forEach(param => {
            const key = param.substring(1, param.length);
            url = obj.hasOwnProperty(key) ?
                url.replace(param, obj[key]) :
                url.replace('/' + param, '');
        });
        return url;
    }
};
ResourceService = __decorate$1([
    Injectable(),
    __metadata("design:paramtypes", [HttpClient])
], ResourceService);

var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
// Imports from @angular
// Services
let ResourceModule = class ResourceModule {
};
ResourceModule = __decorate([
    NgModule({ providers: [ResourceService] })
], ResourceModule);

/**
 * Generated bundle index. Do not edit.
 */

export { ResourceModule, BaseResourceConfig, ResourceService };
//# sourceMappingURL=ng-restly.js.map
